import json
import random
import requests
import validators
from requests.auth import HTTPBasicAuth

from pyModules.GuardPoint.api_exceptions import CardsAPIError


class CardsAPI:
    _cmd_new_card = json.loads('''{
          "description": "Sensor Sign-in",
          "cardCode": "1234567890",
          "status": "Used",
          "cardholderUID": null,
          "cardType": "Wiegand",
          "technologyType": 5
        }''')

    # @staticmethod
    # def _sxor(s1, s2):
    #     # convert strings to a list of character pair tuples
    #     # go through each tuple, converting them to ASCII code (ord)
    #     # perform exclusive or on the ASCII code
    #     # then convert the result back to ASCII (chr)
    #     # merge the resulting array of characters as a string
    #     return ''.join(chr(ord(a) ^ ord(b)) for a, b in zip(s1, s2))

    @staticmethod
    def generate_card_code():
        # _card_code_hdr = "SA"
        # _key = "Sensor-1234-Access-1234-dfsfdsaf"
        # x = _card_code_hdr
        # x = x.join(random.choices(string.ascii_letters + string.digits, k=14))
        # x = CardsAPI._sxor(x, _key)
        # x = binascii.b2a_hex(x.encode())
        # x = x.decode()

        # Create 10 digit dec number (max for reader) between 0x0 and 0xFFFFFFFF and convert to 8 char hex.
        x = format(random.randint(1, 4294967295), 'X')
        # TODO check if code already exists
        return x

    def __init__(self, app_config):
        if not validators.url(app_config['GP10']['base_url']):
            raise ValueError('Bad URL')
        self.url = app_config['GP10']['base_url'] + "/odata/API_Cards"
        self.auth = HTTPBasicAuth(app_config['GP10']['api_user'], app_config['GP10']['api_key'])

    # Returns newly created Card's UID on Success
    def create_new_card(self, card_holder_uid=None, card_code=None):
        if card_holder_uid:
            if not validators.uuid(card_holder_uid):
                raise ValueError('BadRequest - card_holder_uid')
        if not card_code:
            card_code = CardsAPI.generate_card_code()

        self._cmd_new_card["cardholderUID"] = card_holder_uid
        self._cmd_new_card["cardCode"] = card_code

        response = requests.post(self.url, auth=self.auth, json=self._cmd_new_card)
        print(self._cmd_new_card)

        if response.status_code == requests.codes['created']:
            new_card = response.json()
            return new_card['uid']
        elif response.status_code == requests.codes['unprocessable_entity']:
            raise CardsAPIError("BadRequest - Card Already Exists")
        else:
            print("response.status_code: " + str(response.status_code))
            print(self._cmd_new_card)
            print(response.content)
            raise CardsAPIError("Failed to create new Card on GP Server")
