import json

import requests
import validators

from pyModules.GuardPoint.api_cardholders import REQUEST_TIMEOUT
from pyModules.bearerToken import BearerAuth


class TokenAPIError(Exception):
    pass


class TokenAPI:
    cmd_token_auth = json.loads('''{
            "username":"admin", 
            "password":"admin"
            }''')
    cmd_token_renew = json.loads('''{
                "oldToken":""
                }''')

    def __init__(self, app_config):
        if not validators.url(app_config['GP10']['base_url']):
            raise ValueError('Bad base_url: ' + app_config['GP10']['base_url'])
        self.url = app_config['GP10']['base_url'] + "/api/Token"

    def get_token(self, username, password):
        self.cmd_token_auth['username'] = username
        self.cmd_token_auth['password'] = password

        response = requests.post(self.url, json=self.cmd_token_auth, timeout=REQUEST_TIMEOUT)

        if response.status_code == requests.codes.ok:
            token_response = response.json()
            return token_response['token']
        else:
            raise TokenAPIError(f"Failed to get back GP Token. (HTTP Status Code: {response.status_code})")

    def renew_token(self, token):
        self.cmd_token_renew['oldToken'] = token
        bearer_auth = BearerAuth(token)

        response = requests.post(self.url + "/RenewToken", json=self.cmd_token_renew, auth=bearer_auth, timeout=REQUEST_TIMEOUT)

        if response.status_code == requests.codes.ok:
            token_response = response.json()
            return token_response['token']
        else:
            raise TokenAPIError(f"Failed to renew GP Token. (HTTP Status Code: {response.status_code})")