import os


class RegisterDataBase:

    def __init__(self, app_config):
        if "LOCAL_SERVER" in os.environ:
            from pyModules.RequestDatabase.register_db_local import RegisterDataBaseLocal
            self.db = RegisterDataBaseLocal(app_config['RequestDatabase']['max_records'])
        else:
            from pyModules.RequestDatabase.register_db_aws import RegisterDataBaseDynamo
            self.db = RegisterDataBaseDynamo()

    def insert_visitor_request(self, firstName, lastName, company, email, photo, signature):
        return self.db.insert_visitor_request(firstName, lastName, company, email, photo, signature)

    def get_visitor_request(self, request_id):
        return self.db.get_visitor_request(request_id)

    def get_visitor_requests(self, offset=0, count=10):
        return self.db.get_visitor_requests()
