import base64
import io
import re
from PIL import Image


def str_to_b64(msg):
    buffer = base64.b64encode(msg.encode('UTF-8'))
    return buffer.decode('UTF-8')


def is_hex(hex_str):
    try:
        int(hex_str, 16)
        return True
    except:
        return False


def is_base64(b64_str):
    expression = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)?$"
    matches = re.match(expression, b64_str)
    if matches:
        return True
    else:
        return False


def resize_image(base64_image_str):
    buffer = io.BytesIO()
    imgdata = base64.b64decode(base64_image_str)
    img = Image.open(io.BytesIO(imgdata))
    new_img = img.resize((240, 240), Image.NEAREST)
    new_img.save(buffer, format="PNG")
    img_b64 = base64.b64encode(buffer.getvalue())
    return img_b64.decode()