import {apiVms} from "/js/modules/api_vms.mjs";
import {cookieVms} from "/js/modules/cookie.mjs";

/* Always erase cookie, on Login screen */
cookieVms.erase();

function login(){
    var username = document.getElementById('uname').value;
    var password = document.getElementById('psw').value;

    apiVms.getToken(username, password,
        function(data) {  /* OnSuccess */
            cookieVms.set(data.token);
            window.location = "/Admin.html" + window.location.search;
        },
        function(msg) {  /* OnFailure */
            console.log("Failed to get Token");
        })
}



/* Expose function to global scope */
window.login = login;

// Display the Login Prompt
window.onload = function(){
    let modal = document.getElementById('id01');
    modal.style.display='block';

    document.getElementById("psw").addEventListener('keydown', (e) => {
            if(e.code === 'Enter') {
                login();
            };
        });
};

// When the user clicks anywhere outside of the modal, close it
window.onclick = function(event) {
    let modal = document.getElementById('id01');
    if (event.target == modal) {
        modal.style.display = "none";
    }
};