export const cookieVms = {

    name: "SensorVMSCookie",
    minutes: 55,

    parseJwt: function(token) {
        if(token){
            var base64Url = token.split('.')[1];
            var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
            var jsonPayload = decodeURIComponent(atob(base64).split('').map(function(c) {
                return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
            }).join(''));
            return JSON.parse(jsonPayload);
        }
        return null;
    },

    set: function(token) {
        document.cookie = cookieVms.name + "=" + (token || "")  + "; Max-Age=" +cookieVms.minutes*60+ ";path=/;SameSite=Strict";
    },

    get: function() {
        let nameEQ = cookieVms.name + "=";
        let ca = document.cookie.split(';');
        for(var i=0;i < ca.length;i++) {
            var c = ca[i];
            while (c.charAt(0)==' ') c = c.substring(1,c.length);
            if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
        }
        return null;
    },

    erase: function() {
        document.cookie = cookieVms.name +'=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;SameSite=Strict';
    }
}