
export const utils = {
    /* Every invocation resets the timer, and reschedules the func 300 ms in the future. */
    debounce: function(func, timeout = 300) {
      let timer;
      return (...args) => {
        clearTimeout(timer);
        timer = setTimeout(() => { func.apply(this, args); }, timeout);
      };
    },

    /* Separates first and last name */
    splitNames: function(nameSearchInput) {
         let firstName = '';
         let lastName = '';
         if(nameSearchInput.length > 3) {
            let res = nameSearchInput.split(" ", 3);
            firstName = res[0];
            if(res.length > 1) {
                lastName = res[1];
            }
         }
         return [firstName, lastName];
    }

};